/**
 * @author fezaichaker
 */


/*variables de recuperation des Objets dans la page html
 * button   
 * canvas  
 */
  var canvas = null; //canvas object
  var context = null; //canvas's context object
  var clearBtn = null; //clear button object
  var saveBtn = null;
  var fillBtn = null;
  var colors = null;
  var dataURL = null;
  var cxt = null;
  var brush = null;
  /*boolean var to check if the touchstart event
  is caused and then record the initial co-ordinate*/
  var buttonDown = false;

  //onLoad event register
  window.addEventListener('load', initApp, false);

  function initApp() {
    setTimeout(function() { window.scrollTo(0, 1); }, 10); //hide the address bar of the browser.
    canvas = document.getElementById('paintBox');
    clearBtn = document.getElementById('clearBtn');
	saveBtn = document.getElementById('saveBtn');
	fillBtn = document.getElementById('fillBtn');
	colors = document.getElementById('wColorPicker3_2');
	$("select").change(sizeBrush);
    initColors();
    sizeBrush();
    setCanvasDmiension();
    context = canvas.getContext('2d'); //get the 2D drawing context of the canvas
    initializeEvents();
    
    
}

function setCanvasDmiension() {
  canvas.width = window.innerWidth;
  canvas.height = window.innerHeight; //setting the height of the canvas
}

function initializeEvents() {
  canvas.addEventListener('touchstart', startPaint, false);
  canvas.addEventListener('touchmove', continuePaint, false);
  canvas.addEventListener('touchend', stopPaint, false);
  clearBtn.addEventListener('touchend', clearCanvas,false);  
  saveBtn.addEventListener('touchend', onSave, false);
  fillBtn.addEventListener('touchend', Onbackground, false);
 
}

function clearCanvas() {
  context.clearRect(0,0,canvas.width,canvas.height);
}

function startPaint(evt) {
  if(!buttonDown)
  {
    context.beginPath();
    context.moveTo(evt.touches[0].pageX, evt.touches[0].pageY);
    buttonDown = true;
    dataURL = canvas.toDataURL();
  }
  evt.preventDefault();
}

function continuePaint(evt) {
  if(buttonDown)
  {
  	context.lineWidth = brush;
    context.lineCap = 'round' ;
    context.lineTo(evt.touches[0].pageX,evt.touches[0].pageY);
    context.strokeStyle = cxt;
    context.stroke();
        
  }
}

function stopPaint() {
  buttonDown = false;
  
}

function onSave() {
    var img = canvas.toDataURL("image/png");
    document.write('<img src="' + img + '"/>');
}

	
function initColors(){
	$("#wColorPicker3_2").wColorPicker({
		color: "orange",
		initColor: "#33CCCC",
		onSelect: function(color){			
			cxt = color;
		},
		mode: "click",
		effect: "fade",
		showSpeed: 200,
		hideSpeed: 200
	});
	
}

function Onbackground() {
    // Start a new path to begin drawing in a new color.
    context.closePath();
    context.beginPath();	
    context.fillStyle = cxt; //context.strokeStyle;
    context.fillRect(0, 0, canvas.width, canvas.height);
    
}

function sizeBrush(){
	 var singleValues = $("#size").val();
	 brush = $("#size").val();
	 
}







